version: '3.9'
services:
# swarm can use locally available images
# run 'docker build -t test-config-manager config-manager/' to build this image
# NOTE: pay attention to the second volume, the telegraf_owm configuration is in
# /etc/telegraf_owm/telegraf.conf --> container port 8080 is mapped on host port 8888
  config-manager:
    image: config-manager
    hostname: config-manager
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
      - ./config:/etc/monitoring_platform_configuration:rw
      - ./config-manager/configuration:/usr/src/app/configuration
      - /var/log/configmanager.log:/var/log/configmanager.log
    ports:
      - "8888:8080"
    deploy:
      mode: replicated
      replicas: 1
      restart_policy:
        condition: any
        delay: 5s
        max_attempts: 3
    networks:
      - monitoring_network
##
##
  postgres:
    image: postgres:alpine3.15
    hostname: postgres
    environment:
      - POSTGRES_USER=postgres
      - POSTGRES_PASSWORD=nextworks
    volumes:
      - ./data/postgres:/var/lib/postgresql/data
    deploy:
      mode: replicated
      replicas: 1
    networks:
      - monitoring_network
###
###
  starfish_stub:
    hostname: starfish_stub
    image: starfish_stub
    deploy:
      mode: replicated
      replicas: 1
      restart_policy:
        condition: any
        delay: 5s
        max_attempts: 3
    networks:
      - monitoring_network
###
###
  nwdaf_stub:
    hostname: nwdaf_stub
    image: nwdaf_stub
    deploy:
      mode: replicated
      replicas: 1
      restart_policy:
        condition: any
        delay: 5s
        max_attempts: 3
    networks:
      - monitoring_network
###
###
  telegraf_starfish:
    image: telegraf:1.21.2-alpine
    hostname: telegraf_ransim
    environment:
      - DOCKER_INFLUXDB_INIT_ORG=nextworks
      - DOCKER_INFLUXDB_INIT_BUCKET=monitoring
      - DOCKER_INFLUXDB_INIT_ADMIN_TOKEN=monitoringToken
    volumes:
      - ./config/telegraf_starfish/telegraf.conf:/etc/telegraf/telegraf.conf:rw
    ports:
      - "9275:9275"
    deploy:
      mode: replicated
      replicas: 1
      update_config:
        parallelism: 2
        delay: 5s
        failure_action: rollback
        monitor: 5s
        order: start-first
      restart_policy:
        condition: any
        delay: 5s
        max_attempts: 3
    networks:
      - monitoring_network
###
###
  telegraf_ransim:
    image: telegraf_ransim
    hostname: telegraf_ransim
# these values must be the same of the env variables inside influxdbv2 service
    environment:
      - DOCKER_INFLUXDB_INIT_ORG=nextworks
      - DOCKER_INFLUXDB_INIT_BUCKET=monitoring
      - DOCKER_INFLUXDB_INIT_ADMIN_TOKEN=monitoringToken
    volumes:
      - ./config/telegraf_ransim/telegraf.conf:/etc/telegraf/telegraf.conf:rw
    ports:
      - "9276:9276"
    deploy:
      mode: replicated
      replicas: 1
      update_config:
        parallelism: 2
        failure_action: rollback
        order: start-first
      restart_policy:
        condition: any
        delay: 5s
        max_attempts: 3
    networks:
      - monitoring_network
##
##
  telegraf_nwdaf:
    image: telegraf:1.21.2-alpine
    hostname: telegraf_nwdaf
# these values must be the same of the env variables inside influxdbv2 service
    environment:
      - DOCKER_INFLUXDB_INIT_ORG=nextworks
      - DOCKER_INFLUXDB_INIT_BUCKET=monitoring
      - DOCKER_INFLUXDB_INIT_ADMIN_TOKEN=monitoringToken
    volumes:
      - ./config/telegraf_nwdaf/telegraf.conf:/etc/telegraf/telegraf.conf:rw
      - ./telegraf_nwdaf/processor/nwdaf_conditional_renaming.star:/home/telegraf/nwdaf_conditional_renaming.star
    ports:
      - "9274:9274"
    deploy:
      mode: replicated
      replicas: 1
      update_config:
        parallelism: 2
#        delay: 5s
        failure_action: rollback
#        monitor: 5s
        order: start-first
      restart_policy:
        condition: any
        delay: 5s
        max_attempts: 3
    networks:
      - monitoring_network
##
##
  telegraf_owm:
    image: telegraf:1.21.2-alpine
    hostname: telegraf_owm
# these values must be the same of the env variables inside influxdbv2 service
    environment: 
      - DOCKER_INFLUXDB_INIT_ORG=nextworks 
      - DOCKER_INFLUXDB_INIT_BUCKET=monitoring 
      - DOCKER_INFLUXDB_INIT_ADMIN_TOKEN=monitoringToken 
    volumes:
      - ./config/telegraf_owm/telegraf.conf:/etc/telegraf/telegraf.conf:rw
    ports:
     - "9273:9273"
    deploy:
      mode: replicated
      replicas: 1
      update_config:
        parallelism: 2
        failure_action: rollback
        order: start-first
      restart_policy:
        condition: any
        delay: 5s
        max_attempts: 3
    networks:
      - monitoring_network
##
##
  prometheus:
    hostname: prometheus
    image: prom/prometheus:v2.32.1
    user: root
    volumes:
      - ./config/prometheus/:/etc/prometheus/
      - ./data/prometheus:/data
    command:
      - '--config.file=/etc/prometheus/prometheus.yml'
      - '--storage.tsdb.path=/data'
      - '--web.enable-lifecycle'
    ports:
      - 9090:9090
    deploy:
      mode: replicated
      replicas: 1
      update_config:
        parallelism: 2
        delay: 5s
        failure_action: rollback
        monitor: 5s
        order: start-first
    networks:
      - monitoring_network
###
###
  influxdb:
    image: influxdb:2.2.0
    hostname: influxdb
    environment: 
      - DOCKER_INFLUXDB_INIT_MODE=setup
      - DOCKER_INFLUXDB_INIT_USERNAME=monitoring
      - DOCKER_INFLUXDB_INIT_PASSWORD=T3l3gr@f
      - DOCKER_INFLUXDB_INIT_ORG=nextworks
      - DOCKER_INFLUXDB_INIT_BUCKET=monitoring
      - DOCKER_INFLUXDB_INIT_ADMIN_TOKEN=monitoringToken
    volumes:
#      - $PWD/config:/etc/influxdb2 
      - $PWD/data/influxdb:/var/lib/influxdb2
      - $PWD/config/influxdb:/etc/influxdb2
    ports:
      - "8086:8086"
    deploy:
      mode: replicated
      replicas: 1
      update_config:
        parallelism: 2
        delay: 5s
        failure_action: rollback
        monitor: 15s
        order: start-first
    networks:
      - monitoring_network
##
##
  zookeeper:
    image: wurstmeister/zookeeper:3.4.6
    hostname: zookeeper
    ports:
      - "2181:2181"
    deploy:
      mode: replicated
      replicas: 1
      update_config:
        parallelism: 2
        delay: 5s
        failure_action: rollback
        monitor: 15s
        order: start-first
      restart_policy:
        condition: on-failure
        delay: 2s
        max_attempts: 5
    networks:
      - monitoring_network
##
##
  kafka:
    image: wurstmeister/kafka:2.13-2.8.1
    hostname: kafka
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
    ports:
      - "9093:9093"
    environment:
      - KAFKA_BROKER_ID=1
      - KAFKA_ADVERTISED_HOST_NAME=kafka
      - KAFKA_ADVERTISED_PORT=2181
      - KAFKA_HOST_NAME=kafka
      - KAFKA_ADVERTISED_LISTENERS=INSIDE://kafka:9092,OUTSIDE://10.5.6.148:9093
      - KAFKA_LISTENER_SECURITY_PROTOCOL_MAP=INSIDE:PLAINTEXT,OUTSIDE:PLAINTEXT
      - KAFKA_LISTENERS=INSIDE://0.0.0.0:9092,OUTSIDE://0.0.0.0:9093
      - KAFKA_INTER_BROKER_LISTENER_NAME=INSIDE
      - KAFKA_ZOOKEEPER_CONNECT=zookeeper:2181
      - KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR=1
      - KAFKA_TRANSACTION_STATE_LOG_REPLICATION_FACTOR=1
      - KAFKA_TRANSACTION_STATE_LOG_MIN_ISR=1
    deploy:
      mode: replicated
      replicas: 1
      update_config:
        parallelism: 2
        delay: 5s
        failure_action: rollback
        monitor: 15s
        order: start-first
      restart_policy:
        condition: on-failure
        delay: 5s
        max_attempts: 5
    networks:
      - monitoring_network
##
##
#  kafka_consumer:
#    image: kafka_consumer
#    hostname: kafka_consumer
#    deploy:
#      mode: replicated
#      replicas: 1
#      update_config:
#        parallelism: 2
#        delay: 5s
#        failure_action: rollback
#        monitor: 15s
#        order: start-first
#    networks:
#      - monitoring_network
##
##
  kafka-ui:
    image: provectuslabs/kafka-ui:0.3.1
    hostname: kafka-ui
    ports:
      - "8080:8080"
    environment:
      - KAFKA_CLUSTERS_0_NAME=local
      - KAFKA_CLUSTERS_0_BOOTSTRAPSERVERS=kafka:9092
      - KAFKA_CLUSTERS_0_ZOOKEEPER=zookeeper:2181
    deploy:
      mode: replicated
      replicas: 1
      update_config:
        parallelism: 2
        delay: 5s
        failure_action: rollback
        monitor: 15s
        order: start-first
      restart_policy:
        condition: on-failure
        delay: 5s
        max_attempts: 5
    networks:
      - monitoring_network
##
##
networks:
  monitoring_network:
    driver: overlay
